
import java.util.List;
import java.util.ArrayList;

/** 
    Component représente à la fois un noeud composé et terminal
**/
public abstract class Component{
    
    protected String name;
    
    protected Component parent = null;
    
    public Component(String name){
        this.name = name;
    }
    
    public String getName(){
        return name;
    }
    
    public void setParent(Component parent){
        this.parent = parent;
    }
    
	public int getLevel(){
		return parent == null ? 0 : parent.getLevel() + 1; 
	}
	
    // opérations utilisant la structure composite
    abstract public void print();
    abstract public int getNombreLivres();
    abstract public int getNombrePages();
    
    
}
